##
##  clearsilver.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package information
Name:         clearsilver
Summary:      Language-Neutral HTML Template System
URL:          http://www.clearsilver.net/
Vendor:       Brandon Long et al.
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        HTML
License:      Neotonic ClearSilver License and others
Version:      0.10.5
Release:      20080101

#   package options
%option       with_perl           no
%option       with_python         no
%option       with_zlib           no

#   list of sources
Source0:      http://www.clearsilver.net/downloads/clearsilver-%{version}.tar.gz

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, make, gcc, python
PreReq:       OpenPKG, openpkg >= 20160101
%if "%{with_perl}" == "yes"
BuildPreReq:  perl
PreReq:       perl
%endif
%if "%{with_zlib}" == "yes"
BuildPreReq:  zlib
PreReq:       zlib
%endif

%description
    Clearsilver is a fast, powerful, and language-neutral HTML template
    system. In both static content sites and dynamic HTML applications,
    it provides a separation between presentation code and application
    logic which makes working with your project easier.

%track
    prog clearsilver = {
        version   = %{version}
        url       = http://www.clearsilver.net/downloads/
        regex     = clearsilver-(__VER__)\.tar\.gz
    }

%prep
    %setup -q
    %{l_shtool} subst \
        -e 's;^#!.*$;#!%{l_prefix}/bin/python;' \
        scripts/document.py
    case "%{l_platform -t}" in
        *-linux* ) ;;
        * )
            %{l_shtool} subst \
                -e '/^#include <features.h>/d' \
                cgi/cgiwrap.c
            ;;
    esac
%if "%{with_zlib}" == "yes"
    %{l_shtool} subst \
        -e 's;^\(LIBS[    ]*+=.*\)$;\1 -lz;' \
        cgi/Makefile
%endif

%build
    CC="%{l_cc}" \
    CFLAGS="%{l_cflags -O}" \
    CPPFLAGS="%{l_cppflags}" \
    LDFLAGS="%{l_ldflags}" \
    INSTALL="%{l_shtool} install%{l_nil} -c" \
    ./configure \
        --prefix=%{l_prefix} \
%if "%{with_zlib}" == "yes"
        --enable-compression \
%else
        --disable-compression \
%endif
        --disable-apache \
%if "%{with_perl}" == "yes"
        --enable-perl \
        --with-perl=%{l_prefix}/bin/perl \
%else
        --disable-perl \
%endif
%if "%{with_python}" == "yes"
        --enable-python \
        --with-python=%{l_prefix}/bin/python \
%else
        --disable-python \
%endif
        --disable-ruby \
        --disable-java \
        --disable-csharp \
        --disable-remote-debugger \
        --disable-gettext
    %{l_make} %{l_mflags -O}

%install

    #   build ClearSilver
    %{l_make} %{l_mflags} install DESTDIR="$RPM_BUILD_ROOT"

    #   prepend namespace to all man pages to avoid conflicts
    ( cd $RPM_BUILD_ROOT%{l_prefix}/man/man3
      for m in *.3; do
          case "$m" in
              cs_* ) continue ;;
          esac
          base=`echo $m | sed -e 's;\.3$;;'`
          mv $m cs_$m
          %{l_shtool} subst \
              -e "1,/^\.SH .SEE ALSO./!s;$base;cs_$base;g" \
              *.3
      done
    ) || exit $?

    #   strip installation
    strip $RPM_BUILD_ROOT%{l_prefix}/bin/* >/dev/null 2>&1 || true
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

